/*

*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "RandMulti.h"


#ifdef  G49
#ifdef  HAVE_SSE4
char	FileName[]= "ChiTest7-G49aSSE4.txt";
#else
char	FileName[]= "ChiTest7-G49a.txt";
#endif
#endif

#ifdef  xor128
char	FileName[]= "ChiTest7-xor.txt";
#endif

#ifdef  mt19937
char	FileName[]= "ChiTest7-mt.txt";
#endif

#ifdef  SFMT
# ifdef HAVE_SSE2
char	FileName[]= "ChiTest7-sfSSE2.txt";
# else
char	FileName[]= "ChiTest7-sfmt.txt";
# endif
#endif


#define		size	16

int main(void)
{
	FILE	*out;

	int i,j,k;
	int  box[size][size];

//	int		ic[20];

	double	t1,t2;

	//	()
	RandInit;

//	for( i=0;i<20;i++ ) ic[i]= 0;
//	int	in= 0;
	double	sum;

//	double	sum2= 0.0;

	t1= (double)clock();

	for( k=0;k<1000;k++ ){

		//	()
		RandInit;

//		sum2= 0.0;
//		in = 0;

		memset( box, 0, sizeof( box ) );

#define  jloop 10000
#define  loop size*size*100

		double	dAve;
		dAve= jloop*loop/size/size;

		for (i = loop ; i > 0 ; i--){
			for( j=jloop ;j>0;j--){

				unsigned int  irand1, irand2;

				irand1= Rand;
				irand2= Rand;

				box[ (irand1 & 0xf) ][ (irand2 & 0xf) ]++;
			}

			{
				double	dd;
				int		ii,jj;

				sum= 0.0;

				for( ii= size-1;ii>=0;ii-- ){
					for( jj= size-1;jj>=0;jj-- ){
						dd= (double)( box[ii][jj] - dAve );
						sum += dd*dd;
					}
				}
				sum /= dAve;
			}
		} // for( j )

		t2= (double)clock();

		printf(" k= %5d ChiSq= %f\t", k, sum );
		printf("\t%x,%x,%x,%x\t",p1,p2,p3,p4);
		printf(" %.3f sec\n",  (t2-t1)/(double)CLOCKS_PER_SEC );

		out = fopen( FileName , "at");

		fprintf( out, " k= %5d ChiSq= %f\t", k, sum );
		fprintf( out, "\t%x,%x,%x,%x\t",p1,p2,p3,p4);
		fprintf( out, " %.3f sec\n",  (t2-t1)/(double)CLOCKS_PER_SEC );

		fclose( out );

	}	// k

	return( 0 );
}
