/*
om
75	2.818141017102702e-007	16777216	4.7280560562		2.3640280281
70	3.925069822796835e-005	16777216	658.5174423214		329.2587211607
65	1.758820861485079e-003	16777216	29508.1174984413	14754.05874922065
60	2.844396682049040e-002	16777216	477210.575244201
55	1.841008086633481e-001	16777216	3088699.03271966

*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>
double		t0,	t1;

#include "RandMulti.h"

char	fileName[]="outData.txt";
FILE	*out;

double	readData();

int main(int argc,char *argv[] )
{
	//	FILE	*out;

	int i,j,k;//,ilp;
	int	ratio;
	//#define		Mask	(1<<0)
	int	Mask= 1;
	int	shift=0;

	int	iLoop=	(1<<24);	//	< 1e10 ł邱, 1<<29  OK
	int	jLoop=  1;

	int	iiLoop= 1000;

	clock();

	if( argc>= 2 ){
		shift= atoi( argv[1] );
		if( shift< 0 ) shift= 0;
		if( shift> 31 ) shift= 31;
	}
	printf("shift= %d\t", shift );

	ratio=75;
	if( argc>= 3 ){
		ratio= atoi( argv[2] );
		if( ratio< 51 ) ratio= 51;
		if( ratio>99 ) ratio= 99;
	}
	printf("ratio= %d\t", ratio );

	if( argc>= 4 ){
		jLoop= atoi( argv[3] );
		if( jLoop < 1 ) jLoop=1;
		//if( jLoop > 64 ) jLoop= 64;
	}
	printf("Loop= %d\t",jLoop );

	if( argc>= 5 ){
		iiLoop= atoi( argv[4] );
		if( iiLoop < 1 ) iiLoop=1;
	}
	printf("iiLoop= %d\t",iiLoop );
	printf("\n");


	int	ii;
/*
	out= fopen( fileName, "wt" );
	fclose( out );
*/
	for( ii=0;ii< iiLoop;ii++ ){

		//	();
		RandInit

		int		nCount= 0;
		int		nCount2= 0;
		int		nOK1= 0;
		int		nNG1= 0;
		int		nOK0= 0;
		int		nNG0= 0;

		//	()
		RandInit

		printf("%8x, %8x, %8x, %8x\n",p1,p2,p3,p4);

		t0= (double)clock();

		nCount= 0;
		nCount2= 0;

		nOK1= 0;
		nNG1= 0;
		nOK0= 0;
		nNG0= 0;

		for( j=jLoop;j>0;j--){
			for (i = iLoop; i >0 ; i--) {

				int		i1= 0;
				int		i0= 0;
				int		ii;

				nCount++;
				for( k=100;k>0;k-- ){
					ii= (Rand) & Mask;
					if( ii != 0 )	i1++;
					else			i0++;
				}

				ii= (Rand) & Mask;

				if( i1 >= ratio ){
					if( ii != 0 ){
						nOK1++;
					}else{
						nNG1++;
					}
					continue;
				}

				if( i0 >= ratio ){
					if( ii == 0 ){
						nOK0++;
					}else{
						nNG0++;
					}
					continue;
				}

			}

#define  iTh  100000000

			// ̈ʒuɐݒuBnCount ́AꎞIɂ 1e10 𒴂BiLoop ́A1e10 ȉł鎖
			while( nCount >= iTh ){	// 10AO͂X
				nCount2++;
				nCount -= iTh;
			}
		}

		t1= (double)clock();

		//	printf("0: ok= %d\tng= %d\tn= %d%09d\n", nOK0, nNG0, nCount2, nCount );
		//	printf("1: ok= %d\tng= %d\tn= %d%09d\n", nOK1, nNG1, nCount2, nCount );

		double	dd;
		printf("n= %.0f\n", dd= (double)nCount2*(double)iTh+(double)nCount );
		printf("Ideal= %.2f\n", dd= readData(ratio)*dd*0.5 );
		printf("Ave=   %.2f\n", ((double)nOK0+(double)nNG0+(double)nOK1+(double)nNG1)/4.0 );

		printf("0: 0-0= %d\t0-1= %d\n", nOK0, nNG0 );
		printf("1: 1-1= %d\t1-0= %d\n", nOK1, nNG1 );

		double	d00, d01, d10, d11;
		d00= nOK0-dd; d01= nNG0-dd; d11= nOK1-dd; d10= nNG1-dd;
		dd= ( d00*d00 + d01*d01 + d11*d11 + d10*d10 )/dd;
		printf(" %.3f  sec\tChiSQ= %.2f\n",(t1-t0)/CLOCKS_PER_SEC, dd );

		out= fopen( fileName, "at" );
		{
			static int	fg= 1;
			if( fg ){
				fprintf( out, "-----------------------\n" );
				fg= 0;
			}
		}
		fprintf( out, "Ave=   %.2f\t", ((double)nOK0+(double)nNG0+(double)nOK1+(double)nNG1)/4.0 );
		fprintf( out, "0-0=\t%d\t0-1=\t%d\t1-1=\t%d\t1-0\t%d\t", nOK0, nNG0, nOK1, nNG1 );
		fprintf( out, " %.3f  sec\tChiSQ= %.2f\n",(t1-t0)/CLOCKS_PER_SEC, dd );
		fclose( out );

	}

	return( 0 );
}

double	readData( int ii ){
	double	data[128];
	memset( data, 0, sizeof( data ) );
	data[	100	]=	7.888609052210118e-031	;
	data[	99	]=	7.967495142732219e-029	;
	data[	98	]=	3.984536432271331e-027	;
	data[	97	]=	1.315433448065089e-025	;
	data[	96	]=	3.224844447881771e-024	;
	data[	95	]=	6.261622562692680e-023	;
	data[	94	]=	1.002979760961807e-021	;
	data[	93	]=	1.363071866403019e-020	;
	data[	92	]=	1.604281834122002e-019	;
	data[	91	]=	1.661024489726826e-018	;
	data[	90	]=	1.531645087718993e-017	;
	data[	89	]=	1.270426667746153e-016	;
	data[	88	]=	9.556787680138534e-016	;
	data[	87	]=	6.564907761017926e-015	;
	data[	86	]=	4.142225936040038e-014	;
	data[	85	]=	2.412710751968598e-013	;
	data[	84	]=	1.302967909328050e-012	;
	data[	83	]=	6.548999325035109e-012	;
	data[	82	]=	3.073903307523988e-011	;
	data[	81	]=	1.351381261024394e-010	;
	data[	80	]=	5.579544528625976e-010	;
	data[	79	]=	2.168683316710819e-009	;
	data[	78	]=	7.952664236893070e-009	;
	data[	77	]=	2.756790387925027e-008	;
	data[	76	]=	9.050013106514628e-008	;
	data[	75	]=	2.818141017102702e-007	;
	data[	74	]=	8.336813247250505e-007	;
	data[	73	]=	2.346206306321115e-006	;
	data[	72	]=	6.289575008339427e-006	;
	data[	71	]=	1.608000764783317e-005	;
	data[	70	]=	3.925069822796835e-005	;
	data[	69	]=	9.157161244117683e-005	;
	data[	68	]=	2.043885837134076e-004	;
	data[	67	]=	4.368599184561862e-004	;
	data[	66	]=	8.949651957434263e-004	;
	data[	65	]=	1.758820861485079e-003	;
	data[	64	]=	3.318560257963063e-003	;
	data[	63	]=	6.016487862681739e-003	;
	data[	62	]=	1.048936783892586e-002	;
	data[	61	]=	1.760010010885241e-002	;
	data[	60	]=	2.844396682049040e-002	;
	data[	59	]=	4.431304005703379e-002	;
	data[	58	]=	6.660530960360667e-002	;
	data[	57	]=	9.667395224782123e-002	;
	data[	56	]=	1.356265120369174e-001	;
	data[	55	]=	1.841008086633481e-001	;
	data[	54	]=	2.420592068036457e-001	;
	data[	53	]=	3.086497067946260e-001	;
	data[	52	]=	3.821767172013334e-001	;
	data[	51	]=	4.602053813064106e-001	;

	return( data[ ii ] );
}
