#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>
#include <time.h>

#include "RandMulti.h"

int		count= 10;
int		count1= 0;
int		count2= 0;
int		count3= 0;
int		count4= 0;
int		count5= 0;

int		iAll=0;


#define  loop 10000 // zvf̊ҒlFƗ_lO₷i傫߂ɂȂBj

#define size 128	//	z̃TCY
const int	iLimit= (4096*64*64)/size/size;	// P̎́@Loopsize= 128 => 1024

//128x128		0.050,	0.075.	0.100,	0.125,	0.150
const double	a1= 16681.8739101661;
const double	a2= 16644.2855547248;
const double	a3= 16615.4025676278;
const double	a4= 16591.4406538829;
const double	a5= 16570.6544526712;

/*
//64x64		0.050,	0.075.	0.100,	0.125,	0.150
const double	a1= 4244.985307925470;
const double	a2= 4225.981720736540;
const double	a3= 4211.398461928260;
const double	a4= 4199.312550031270;
const double	a5= 4188.837718376500;
*/

/*
// 32x32 Libre
const double	a1= 1098.520781924600;
const double	a2= 1088.811295213260;
const double	a3= 1081.379444173550;
const double	a4= 1075.232946270400;
const double	a5= 1069.915112900680;
*/

/*
// 16x16 Libre
const double	a1= 293.2478350807010;
const double	a2= 288.1889159937030;
const double	a3= 284.3359078234510;
const double	a4= 281.1619788592910;
const double	a5= 278.4252983558160;
*/

/*
//8x8 Libre
const double	a1= 82.52872654147180
const double	a2= 79.80247114219330
const double	a3= 77.74538483569490
const double	a4= 76.06362642530760
const double	a5= 74.62295712071980
*/

time_t	t0,t1;

int main(int argc,char *argv[] )
{
	if( argc== 1 ) count= 10;
	else{
		count= atoi( argv[1] );
		if( count <= 0 ) count= 10;
		else if( count >= 1000 ) count= 10;
	}

	fprintf( stderr, "%s\t%d\n", argv[0], count );

//--

	int	i,j,ii;
	int	k;
	int	st[16];
	unsigned array[size][size];



	//	RandInit

//	t0= clock();

	while( count-- ){

		RandInit;	// faster	size * size * loop * 15 *4096  񏉊

		t0= clock();
		iAll= 0;
		count1= count2= count3= count4= count5= 0;

		do{

			//		RandInit;	// faster	size * size * loop * 15  񏉊

			for( k=1;k<16;k++ ){

				//				RandInit;

				for( i=0;i<16;i++ ) st[i]= (Rand) & (size-1);

				memset( array, 0, sizeof( array ) );
				/*
				for( i=0;i<size;i++ ){
					for( j=0;j<size;j++ ){
						array[i][j]= 0;
					}
				}
				*/

				for( i=0;i<loop;i++ ){
					for( ii= 0;ii<size*size;ii++ ){
						for( j=0; ;j++ ){
							if( j==k ){
								st[k]= (Rand) & (size-1);
								//			printf("%x \n",st[k] );
								break;
							}
							st[j]=st[j+1];
						}

						array[ st[0] ][ st[k] ]++;
					}
				}

				int	isum= 0;
				int	idmy;

				for( i=0;i<size;i++ ){
					for( j=0;j<size;j++ ){
						idmy= array[i][j] - loop;
						isum += idmy * idmy;
					}
				}

				double	sum;
				sum =  (double)isum / (double)loop;

				if( sum > a5 ){
					if( sum <= a4 ){ count1++; }
					else if( sum <= a3 ){ count1++; count2++; }
					else if( sum <= a2 ){ count1++; count2++; count3++; }
					else if( sum <= a1 ){ count1++; count2++; count3++; count4++; }
					else { count1++; count2++; count3++; count4++; count5++; }
				}

				iAll++;
				if( iAll == iLimit ){
					double	da1,da2,da3,da4,da5;
					double	dd1,dd2,dd3,dd4,dd5;

					da1= (double)count1/(double)iAll;  dd1= da1/0.150;
					da2= (double)count2/(double)iAll;  dd2= da2/0.125;
					da3= (double)count3/(double)iAll;  dd3= da3/0.100;
					da4= (double)count4/(double)iAll;  dd4= da4/0.075;
					da5= (double)count5/(double)iAll;  dd5= da5/0.050;

					printf("Loop=\t%7d\t%f\t%f\t%f\t%f\t%f\t", iAll, dd1, dd2, dd3, dd4, dd5 );

					t1= clock();
					printf("time=\t%9.3f\tsec\t", (t1-t0)/(double)CLOCKS_PER_SEC );

					int	cnt=0;
					const double dULim= 1.05;
					const double dLLim= 1.0/1.05;
					if( ( dd1 < dULim ) && ( dd1 > dLLim  ) ) cnt++;
					if( ( dd2 < dULim ) && ( dd2 > dLLim  ) ) cnt++;
					if( ( dd3 < dULim ) && ( dd3 > dLLim  ) ) cnt++;
					if( ( dd4 < dULim ) && ( dd4 > dLLim  ) ) cnt++;
					if( ( dd5 < dULim ) && ( dd5 > dLLim  ) ) cnt++;

					if( cnt<=2 )	printf("NG %d\t",cnt);
					else			printf("OK %d\t",cnt);

					da1= ( da1 - 0.150 ); da1= da1*da1/0.150;
					da2= ( da2 - 0.125 ); da2= da2*da2/0.125;
					da3= ( da3 - 0.100 ); da3= da3*da3/0.100;
					da4= ( da4 - 0.075 ); da4= da4*da4/0.075;
					da5= ( da5 - 0.050 ); da5= da5*da5/0.050;

					double	dd;

//					dd=  (da1-1.0)*(da1-1.0) + (da2-1.0)*(da2-1.0) + (da3-1.0)*(da3-1.0) + (da4-1.0)*(da4-1.0) + (da5-1.0)*(da5-1.0);
//					dd=  sqrt(  dd/5.0 );

					dd= sqrt( ( da1 + da2 + da3 + da4 + da5 )/5.0 );

					printf("%f\n", dd );

					//					iAll2 *=2;

					if( iAll >= iLimit ){
						break;
					}
				}
			}

		}while( iAll < iLimit );

	}

	//	printf("\n\n\n");

	return 0;
}

