gcc -O3 ChiTest8.c -Wall -Dxor128 -msse2 -funroll-loops -ffast-math -finline-functions -mtune=prescott -fomit-frame-pointer -oChiTest8xor.exe
strip  ChiTest8xor.exe

gcc -O3 127-G48e.c -ffast-math -fomit-frame-pointer -mtune=prescott -c -o127-G48e.o -funroll-loops
gcc -O3 ChiTest8.c 127-G48e.o -DG48 -Wall -msse2 -funroll-loops -ffast-math -finline-functions -mtune=prescott -fomit-frame-pointer  -oChiTest8G48e.exe
strip  ChiTest8G48e.exe

gcc -O3 127-G48eSSE.c -mmmx -msse -msse2 -msse4 -ffast-math -fomit-frame-pointer -mtune=prescott -c -funroll-loops
gcc -O3 ChiTest8.c 127-G48eSSE.o -DG48 -DHAVE_SSE4 -Wall -mmmx -msse2 -msse4 -funroll-loops -ffast-math -finline-functions -mtune=prescott -fomit-frame-pointer  -oChiTest8G48eSSE4.exe
strip  ChiTest8G48eSSE4.exe

gcc -O3 ChiTest8.c -Wall -Dmt19937 -msse2 -funroll-loops -ffast-math -mtune=prescott -finline-functions -fomit-frame-pointer  -oChiTest8mt.exe
strip  ChiTest8mt.exe

gcc -O3 ChiTest8.c -Wall -DSFMT -std=c99 -msse2 -funroll-loops -finline-functions -fomit-frame-pointer -ffast-math -mtune=prescott  -oChiTest8sfmt.exe
strip  ChiTest8sfmt.exe

gcc -O3 ChiTest8.c -Wall -DSFMT -std=c99 -DHAVE_SSE2 -msse2 -funroll-loops -finline-functions -fomit-frame-pointer -ffast-math -mtune=prescott  -oChiTest8sfSSE2.exe
strip  ChiTest8sfSSE2.exe
