/***************************
xor128.h

*****************************/
static	 unsigned int MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;
//void		MT_xor_init( const unsigned int p );
//void		MT_xor_init2( const unsigned int pp1, const unsigned int pp2 );
void		MT_xor_init4( const unsigned int pp1, const unsigned int pp2, const unsigned int pp3, const unsigned int pp4 );

inline  static	unsigned int MT_xor128(){
	unsigned int t;
	t=(MT_x^(MT_x<<11));
	MT_x=MT_y;
	MT_y=MT_z;
	MT_z=MT_w;
	return( MT_w=(MT_w^(MT_w>>19))^(t^(t>>8)) );
}

//#####
/*
void	MT_xor_init( const unsigned int pp ){
	int	ii;
	int	p;
	p=pp;
	MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;
	MT_x += p++;
	MT_y += (p<<1)^(p>>1); p++;
	MT_z += (p<<2)^(p>>2); p++;
	MT_w += (p<<3)^(p>>3); p++;
	for( ii= 8; ii>0; ii-- ) MT_xor128();
}
*/


void	MT_xor_init2( const unsigned int pp1, const unsigned int pp2 ){
	int	ii;
	unsigned int	p1, p2, p3, p4;
	p1= (pp1<<8)+(pp2<<2)+1;
	p2= (pp1<<6)+(pp2<<4)+3;
	p3= (pp1<<4)+(pp2<<6)+5;
	p4= (pp1<<2)+(pp2<<8)+7;

	MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;
	MT_x += (p1<<3)^(p1>>1);
	MT_y += (p2<<3)^(p2>>1);
	MT_z += (p3<<3)^(p3>>1);
	MT_w += (p4<<3)^(p4>>1);
	for( ii= 6; ii>0; ii-- ) MT_xor128();
}


void		MT_xor_init4( const unsigned int pp1, const unsigned int pp2, const unsigned int pp3, const unsigned int pp4 ){
	int	ii;
	unsigned int	p1, p2, p3, p4;
	p1= pp1+(pp2<<2)+(pp3<<4)+(pp4<<6)+1;
	p2= pp2+(pp3<<2)+(pp4<<4)+(pp1<<6)+3;
	p3= pp3+(pp4<<2)+(pp1<<4)+(pp2<<6)+5;
	p4= pp4+(pp1<<2)+(pp2<<4)+(pp3<<6)+7;

	MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;
	MT_x += (p1<<3)^(p1>>1);
	MT_y += (p2<<3)^(p2>>1);
	MT_z += (p3<<3)^(p3>>1);
	MT_w += (p4<<3)^(p4>>1);
	for( ii= 6; ii>0; ii-- ) MT_xor128();
}


