#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "RandMulti.h"

void	func01(void);
void	func02(void);
void	func03(void);
void	func04(void);
void	func05(void);
void	func06(void);
void	func07(void);
void	func08(void);

#define  nn  8
double	ddtime[nn];

/******************************/

int			jLoop=	840;   // 1-8 ̍ŏ{
//#define		iLoop	300001
int			iLoop=	240001;

double			ddSum= 0.0;
double			maxSpeed=0.0;
double			aveSpeed=0.0;
int				count= 0;

int main(int argc,char *argv[] )
{
	if( argc <= 2 ) printf("\n%s\t%s\n", argv[0], argv[1] );
	else if( argc == 3 ) printf("\n%s\t%s\t%s\n", argv[0], argv[1], argv[2] );

	{
		double		argvRead=100.0;
		if( argc>= 2 ){
			argvRead= atof( argv[1] );
			if( argvRead<1.0 ) argvRead=1.0;
		}
		jLoop *= (int)argvRead;
	}

	{	// RpCɁA[v񐔂sɂ邽߁B
		double		argvRead2=100.0;
		if( argc>= 3 ){
			argvRead2= atof( argv[2] );
			if( argvRead2<1.0 ) argvRead2=1.0;
		}
		iLoop = (int)( (double)iLoop * (argvRead2/100.0) );
	}

	printf("jLoop= %d, iLoop= %d\n", jLoop, iLoop);


	p1= p2= p3= p4=1;
	RandInitP;
	func01();

	p1= p2= p3= p4=1;
	RandInitP;
	func02();

	p1= p2= p3= p4=1;
	RandInitP;
	func03();

	p1= p2= p3= p4=1;
	RandInitP;
	func04();

	p1= p2= p3= p4=1;
	RandInitP;
	func05();

	p1= p2= p3= p4=1;
	RandInitP;
	func06();

	p1= p2= p3= p4=1;
	RandInitP;
	func07();

	p1= p2= p3= p4=1;
	RandInitP;
	func08();

	{
		int	i;
		double	dd, max=0.0, sum=0.0;
		double	totTime=0.0;

		for( i=0; i<nn; i++ ){
			totTime += dd= ddtime[i];
			sum += dd= (double)iLoop*(double)jLoop/dd;
			if( max < dd ) max= dd;
		}

		printf("Total time= %.3f sec\n", totTime );
		printf("  Ave= \t%.3e\t counts/sec\n", sum/(double)nn );
		printf("  Max= \t%.3e\t counts/sec\n", max );

		printf("%x\n", (unsigned int)Rand );
		printf("-------------------\n" );
	}



	return( 0 );
}
//--------------------

void	func01(){
	const int		jnn= 1;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp= 0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);

}

//--------------------

void	func02(){
	const int		jnn=	2;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp= 0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);
}

//--------------------

void	func03(){
	const int		jnn=	3;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp=0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);
}

//--------------------

void	func04(){
	const int		jnn=	4;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp=0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);
}

//--------------------

void	func05(){
	const int		jnn=	5;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp=0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);
}

//--------------------

void	func06(){
	const int		jnn=	6;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp=0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);
}

//--------------------

void	func07(){
	const int		jnn=	7;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp=0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);
}

//--------------------

void	func08(){
	const int		jnn=	8;
	int	i,j;
	double	dd;
	double	tm1, tm2;

	tm1= (double)clock();

	unsigned int	uTemp=0;
	for( j=jLoop/jnn;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
			uTemp &= ( Rand );
		}
	}

	tm2= (double)clock();

	ddtime[jnn-1]= (dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC);
	printf("%d: %8.3f sec\t %8x \t%.3e counts/sec\n", jnn , dd , uTemp , (double)iLoop*(double)jLoop/dd);
}

//------------------------
