//	rev3
//		2011/11/22	RandInit0 𖾎IɌĂ΂ȂĂǂlɕύXB@RandInit0 ́A݊̂߂Ɂ@cB@
//		2011/11/24	unsigned uc; A
//		2011/12/14	rev3	RandInitP ǉ

//#define		xor128
//#define		mt19937
//#define		G48
//#define		SFMT

// RandInit0	Nɏ
// RandInit1	gOɏ

//-----------------------------------------------

#ifndef	time_t
#	include	<time.h>
#endif
/*
#	define	RandInit0			RandInit	// RandMulti.h Ƃ̌݊̂
#	define	RandInit1			RandInit	// ݊̂
*/
#ifdef	G49
#	include "127-G49.h"
	static	int		MT_fInit= 1;

	unsigned int	p1=0,p2=0,p3=0,p4=0;
#	define	RandInit					\
	{									\
		if( MT_fInit ){					\
			p1= p2= MT_fInit= 0;		\
			MT_rr_init(&p1,&p2);		\
		}								\
		p1+= MT_rand32()+clock();		\
		p2+= MT_rand32()+time(NULL);	\
		MT_rr_init(&p1,&p2);			\
	}
#	define	Rand			MT_rand32()
#	define	RandInitP					\
	{									\
		MT_fInit= 0;					\
		MT_rr_init(&p1,&p2);			\
	}
#endif

//----------------------------------
#ifdef	G48
#	include "127-G48.h"
	static	int		MT_fInit= 1;

	unsigned int	p1=0,p2=0,p3=0,p4=0;
#	define	RandInit					\
	{									\
		if( MT_fInit ){					\
			p1= p2= MT_fInit= 0;		\
			MT_rr_init(&p1,&p2);		\
		}								\
		p1+= MT_rand32()+clock();		\
		p2+= MT_rand32()+time(NULL);	\
		MT_rr_init(&p1,&p2);			\
	}
#	define	Rand			MT_rand32()
#	define	RandInitP					\
	{									\
		MT_fInit= 0;					\
		MT_rr_init(&p1,&p2);			\
	}
#endif

//----------------------------------
#ifdef	xor128
#	include "xor128.h"
	static	int		MT_fInit= 1;
	unsigned int	p1=0,p2=0,p3=0,p4=0;
#	define	RandInit				\
	{								\
		if( MT_fInit ){				\
			MT_fInit= 0;			\
			time_t	t1;				\
			unsigned	uc=0;		\
			t1= time(NULL);			\
			while( t1 == time(NULL) )	uc++;	\
			p1+= clock();			\
			p2+= time(NULL)+uc;		\
			MT_xor_init2(p1,p2);	\
		}							\
		p1 += MT_xor128() + clock();	\
		p2 += MT_xor128() + time(NULL);	\
		MT_xor_init2(p1,p2);		\
	}
#	define	Rand			MT_xor128()
#	define	RandInitP				\
	{								\
		MT_fInit= 0;				\
		MT_xor_init2(p1,p2);		\
	}
#endif

//----------------------------------
#ifdef	mt19937
#	include "mt19937ar.c"
	static	int		MT_fInit= 1;
	unsigned int	p1=0,p2=0,p3=0,p4=0;
	unsigned long		init[4]={0,0,0,0};
#	define	RandInit						\
	{										\
		if( MT_fInit ){						\
			MT_fInit= 0;					\
			init[0]= p1 += time( NULL );	\
			init[1]= p2 += clock();			\
			unsigned int	uc=0;			\
			time_t	t1;						\
			t1= time(NULL);					\
			while( t1 == time(NULL) )	uc++;	\
			init[2]= p3 += time( NULL )+uc;	\
			init[3]= p4 += clock();			\
			init_by_array(init, 4);			\
		}									\
		init[0]= p1 += genrand_int32() + clock();		\
		init[1]= p2 += genrand_int32() + time( NULL );	\
		init[2]= p3 += genrand_int32() + clock();		\
		init[3]= p4 += genrand_int32() + time( NULL );	\
		init_by_array(init, 4);					\
	}
#	define	Rand			genrand_int32()
#	define	RandInitP		\
	{						\
		MT_fInit= 0;		\
		init[0]= p1;		\
		init[1]= p2;		\
		init[2]= p3;		\
		init[3]= p4;		\
		init_by_array(init, 4);	\
	}
#endif

//----------------------------------

#ifdef	SFMT

#	ifndef	uint32_t
#		include	<stdint.h>
#	endif

#	define		MEXP  19937
//#	define		HAVE_SSE2
#	include	"SFMT.c"
	static	int		MT_fInit= 1;
	unsigned int	p1=0,p2=0,p3=0,p4=0;
	uint32_t			init[4]={0,0,0,0};
#	define	RandInit						\
	{										\
		if( MT_fInit ){						\
			MT_fInit= 0;					\
			init[0]= p1 += time( NULL );	\
			init[1]= p2 += clock();			\
			unsigned int	uc=0;			\
			time_t	t1;						\
			t1= time(NULL);					\
			while( t1 == time(NULL) )	uc++;		\
			init[2]= p3 += time( NULL )+uc;	\
			init[3]= p4 += clock();			\
			init_by_array(init, 4);			\
		}									\
		init[0]= p1 += gen_rand32() + clock();		\
		init[1]= p2 += gen_rand32() + time( NULL );	\
		init[2]= p3 += gen_rand32() + clock();		\
		init[3]= p4 += gen_rand32() + time( NULL );	\
		init_by_array(init, 4);						\
	}
#	define	Rand		gen_rand32()
#	define	RandInitP		\
	{						\
		MT_fInit= 0;		\
		init[0]= p1;		\
		init[1]= p2;		\
		init[2]= p3;		\
		init[3]= p4;		\
		init_by_array(init, 4);		\
	}
#endif
//----------------------------------
